LIBRARY IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_arith.all;
USE IEEE.std_logic_unsigned.all;

ENTITY testbench_alu IS
END testbench_alu;

ARCHITECTURE testbench_arch OF testbench_alu IS

  component alu
  port(
      ra, rb : in std_logic_vector(15 downto 0);
      ir : in std_logic_vector(5 downto 0);
      alucontrol : in std_logic_vector(1 downto 0);
      aluout : out std_logic_vector(15 downto 0));
  end component alu;

  constant PERIOD : time := 10 ns;

  signal w_ra, w_rb, w_aluout : std_logic_vector(15 downto 0);
  signal w_ir : std_logic_vector(5 downto 0);
  signal w_alucontrol : std_logic_vector(1 downto 0);
  
  signal w_clk : std_logic := '0';

begin
  
  w_clk <= not w_clk after PERIOD / 2 ;
  
  dut : component alu
    port map(
      ra => w_ra,
      rb => w_rb,
      ir => w_ir,
      alucontrol => w_alucontrol,
      aluout => w_aluout);
  
  STIMULI:
  process  is
  begin
    w_ra <= x"0000";
    w_rb <= x"0000";
    w_ir <= "000000";
    w_alucontrol <= "00";
    
    wait for PERIOD;
    w_alucontrol <= "00";
    wait for PERIOD;
    w_alucontrol <= "01";
    wait for PERIOD;
    w_alucontrol <= "10";
    wait for PERIOD;
    w_alucontrol <= "11";
    wait for PERIOD;
    w_ra <= x"a5a5";
    w_rb <= x"0055";
    w_alucontrol <= "00";
    wait for PERIOD;
    w_alucontrol <= "01";
    wait for PERIOD;
    w_alucontrol <= "10";
    wait for PERIOD;
    w_alucontrol <= "11";
    wait for PERIOD;
    w_ir <= "100011";
    w_alucontrol <= "00";
    wait for PERIOD;
    w_alucontrol <= "01";
    wait for PERIOD;
    w_alucontrol <= "10";
    wait for PERIOD;
    w_alucontrol <= "11";
    wait for PERIOD;
    wait;
  end process STIMULI;
end testbench_arch;
      
     
