LIBRARY IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_arith.all;
USE IEEE.std_logic_unsigned.all;

ENTITY testbench_eab IS
END testbench_eab;

ARCHITECTURE testbench_arch OF testbench_eab IS

  component eab
  port(
    ir : in std_logic_vector(10 downto 0);
    ra, pc : in std_logic_vector(15 downto 0);
    seleab1 : in std_logic;
    seleab2 : in std_logic_vector(1 downto 0);
    eabOut : out std_logic_vector(15 downto 0));
  end component eab;

  constant PERIOD : time := 10 ns;

  signal w_ir : std_logic_vector(10 downto 0);
  signal w_ra, w_pc, w_eabout : std_logic_vector(15 downto 0);
  signal w_seleab1 : std_logic;
  signal w_seleab2 : std_logic_vector(1 downto 0);

  signal w_clk : std_logic := '0';

begin
  
  w_clk <= not w_clk after PERIOD / 2 ;
  
  dut : component eab
    port map(
      ir => w_ir,
      ra => w_ra,
      pc => w_pc,
      seleab1 => w_seleab1,
      seleab2 => w_seleab2,
      eabout => w_eabout);

  
  STIMULI:
  process  is
  begin
    w_ir <= "00011001100";
    w_pc <= x"AAAA";
    w_ra <= x"5555";
    w_seleab1 <= '0';
    w_seleab2 <= "00";

    wait for PERIOD;
    w_seleab1 <= '0';
    wait for PERIOD;
    w_seleab1 <= '1';
    wait for PERIOD;
    w_seleab1 <= '0';
    w_seleab2 <= "00";
    wait for PERIOD;
    w_seleab2 <= "01";
    wait for PERIOD;
    w_seleab2 <= "10";
    wait for PERIOD;
    w_seleab2 <= "11";
    wait for PERIOD;
    w_seleab1 <= '1';
    w_seleab2 <= "00";
    wait for PERIOD;
    w_seleab2 <= "01";
    wait for PERIOD;
    w_seleab2 <= "10";
    wait for PERIOD;
    w_seleab2 <= "11";
    wait for PERIOD;
    w_seleab1 <= '0';
    w_seleab2 <= "00";
    wait for PERIOD;
  end process STIMULI;
end testbench_arch;
      
     
