LIBRARY IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_arith.all;
USE IEEE.std_logic_unsigned.all;

ENTITY testbench_ir IS
END testbench_ir;

ARCHITECTURE testbench_arch OF testbench_ir IS

  component ir
  port(
    buss : in std_logic_vector(15 downto 0);
    ldir, clk, reset : in std_logic;
    ir : out std_logic_vector(15 downto 0));
  end component ir;

  constant PERIOD : time := 10 ns;

  signal w_buss, w_ir : std_logic_vector(15 downto 0);
  signal w_ldir, w_reset : std_logic;

  signal w_clk : std_logic := '0';

begin
  
  w_clk <= not w_clk after PERIOD / 2 ;
  
  dut : component ir
    port map(
      buss => w_buss,
      ldir => w_ldir,
      clk => w_clk,
      reset => w_reset,
      ir => w_ir);

  
  STIMULI:
  process  is
  begin
    w_buss <= x"A5A5";
    w_ldir <= '0';
    w_reset <= '0';
    wait for PERIOD;
    w_reset <= '1';
    wait for PERIOD;
    w_reset <= '0';
    wait for PERIOD*2;
    w_ldir <= '1';
    wait for PERIOD;
    w_ldir <= '0';
    wait for PERIOD;
    wait for PERIOD;
    wait;
  end process STIMULI;
end testbench_arch;
      
     
