LIBRARY IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_arith.all;
USE IEEE.std_logic_unsigned.all;

ENTITY testbench_marmux IS
END testbench_marmux;

ARCHITECTURE testbench_arch OF testbench_marmux IS

  component marmux
  port(
    ir : in std_logic_vector(7 downto 0);
    eabOut : in std_logic_vector(15 downto 0);
    selMar : in std_logic;
    marmuxout : out std_logic_vector(15 downto 0));
  end component marmux;

  constant PERIOD : time := 10 ns;

  signal w_eabout, w_marmuxout : std_logic_vector(15 downto 0);
  signal w_ir : std_logic_vector(7 downto 0);
  signal w_selmar : std_logic;
  
  signal w_clk : std_logic := '0';

begin
  
  w_clk <= not w_clk after PERIOD / 2 ;
  
  dut : component marmux
    port map(
      ir => w_ir,
      eabout => w_eabout,
      selmar => w_selmar,
      marmuxout => w_marmuxout);
  
  STIMULI:
  process  is
  begin
    w_ir <= x"AA";
    w_eabout <= x"10AF";
    w_selmar <= '0';
    wait for PERIOD;
    w_selmar <= '1';
    wait for PERIOD;
    w_selmar <= '0';
    wait for PERIOD;
    w_selmar <= '1';
    wait for PERIOD;
    w_selmar <= '0';
    wait for PERIOD;
    wait;
  end process STIMULI;
end testbench_arch;
      
     
