LIBRARY IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_arith.all;
USE IEEE.std_logic_unsigned.all;

ENTITY testbench_nzp IS
END testbench_nzp;

ARCHITECTURE testbench_arch OF testbench_nzp IS

  component nzp
  port(
    buss : in std_logic_vector(15 downto 0);
    clk, regwe, reset : in std_logic;
    n,z,p : out std_logic);
  end component nzp;

  constant PERIOD : time := 10 ns;

  signal w_buss : std_logic_vector(15 downto 0);
  signal w_regwe, w_reset, w_n, w_z, w_p : std_logic;

  signal w_clk : std_logic := '0';

begin
  
  w_clk <= not w_clk after PERIOD / 2 ;
  
  dut : component nzp
    port map(
      buss => w_buss,
      clk => w_clk,
      regwe => w_regwe,
      reset => w_reset,
      n => w_n,
      z => w_z,
      p => w_p);

  
  STIMULI:
  process  is
  begin
    w_buss <= x"A5A5";
    w_regwe <= '0';
    w_reset <= '0';
    wait for PERIOD;
    w_reset <= '1';
    wait for PERIOD;
    w_reset <= '0';
    wait for PERIOD;
    w_regwe <= '1';
    wait for PERIOD;
    w_regwe <= '0';
    wait for PERIOD;
    w_buss <= x"0001";
    w_regwe <= '0';
    wait for PERIOD;
    w_regwe <= '1';
    wait for PERIOD;
    w_regwe <= '0';
    w_buss <= x"0000";
    wait for PERIOD;
    w_regwe <= '1';
    wait;
  end process STIMULI;
end testbench_arch;
      
     
