LIBRARY IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_arith.all;
USE IEEE.std_logic_unsigned.all;

ENTITY testbench_pc IS
END testbench_pc;

ARCHITECTURE testbench_arch OF testbench_pc IS

  component pc
  port(
    buss, eabout : in std_logic_vector(15 downto 0);
    ldpc, clk, reset : in std_logic;
    selpc : in std_logic_vector(1 downto 0);
    pcout : out std_logic_vector(15 downto 0));
  end component pc;

  constant PERIOD : time := 10 ns;

  signal w_buss, w_eabout, w_pcout : std_logic_vector(15 downto 0);
  signal w_ldpc, w_reset : std_logic;
  signal w_selpc : std_logic_vector(1 downto 0);

  signal w_clk : std_logic := '0';

begin
  
  w_clk <= not w_clk after PERIOD / 2 ;
  
  dut : component pc
    port map(
      buss => w_buss,
      eabout => w_eabout,
      ldpc => w_ldpc,
      clk => w_clk,
      reset => w_reset,
      selpc => w_selpc,
      pcout => w_pcout);
  
  STIMULI:
  process  is
  begin
    w_buss <= x"B190";
    w_eabout <= x"248A";
    w_ldpc <= '0';
    w_reset <= '0';
    w_selpc <= "00";
    wait for PERIOD;
    w_reset <= '1';
    wait for PERIOD;
    w_reset <= '0';
    wait for PERIOD;
    wait for PERIOD;
    w_ldpc <= '1';
    wait for PERIOD;
    wait for PERIOD;
    wait for PERIOD;
    wait for PERIOD;        
    w_ldpc <= '0';
    w_selpc <= "01";
    wait for PERIOD;
    w_ldpc <= '1';
    wait for PERIOD;
    w_selpc <= "10";
    w_ldpc <= '0';
    wait for PERIOD;
    w_ldpc <= '1';
    wait for PERIOD;
    wait;
  end process STIMULI;
end testbench_arch;
      
     
