LIBRARY IEEE;
USE IEEE.std_logic_1164.all;
USE IEEE.std_logic_arith.all;
USE IEEE.std_logic_unsigned.all;

ENTITY testbench_regfile IS
END testbench_regfile;

ARCHITECTURE testbench_arch OF testbench_regfile IS

  component regfile
  port(
    buss : in std_logic_vector(15 downto 0);
    dr, sr1, sr2 : in std_logic_vector(2 downto 0);
    regwe, clk, reset : in std_logic;
    ra, rb : out std_logic_vector(15 downto 0));
  end component regfile;

  constant PERIOD : time := 10 ns;

  signal w_buss, w_ra, w_rb: std_logic_vector(15 downto 0);
  signal w_dr, w_sr1, w_sr2 : std_logic_vector(2 downto 0);
  signal w_regwe, w_reset : std_logic;

  signal w_clk : std_logic := '0';

begin
  
  w_clk <= not w_clk after PERIOD / 2 ;
  
  dut : component regfile
    port map(
      buss => w_buss,
      dr => w_dr,
      sr1 => w_sr1,
      sr2 => w_sr2,
      regwe => w_regwe,
      clk => w_clk,
      reset => w_reset,
      ra => w_ra,
      rb => w_rb);

  
  STIMULI:
  process  is
  begin
    w_buss <= x"0000";
    w_regwe <= '0';
    w_reset <= '0';
    w_dr <= "000";
    w_sr1 <= "000";
    w_sr2 <= "000";
    wait for PERIOD;
    w_reset <= '1';
    wait for PERIOD;
    w_reset <= '0';
    wait for PERIOD*2;
    w_buss <= x"FF00";
    w_regwe <= '1';
    wait for PERIOD;
    w_dr <= "001";
    w_buss <= x"FF01";    
    wait for PERIOD;
    w_dr <= "010";
    w_buss <= x"FF02";        
    wait for PERIOD;
    w_dr <= "011";
    w_buss <= x"FF03";        
    wait for PERIOD;
    w_dr <= "100";
    w_buss <= x"FF04";        
    wait for PERIOD;
    w_dr <= "101";
    w_buss <= x"FF05";        
    wait for PERIOD;
    w_dr <= "110";
    w_buss <= x"FF06";        
    wait for PERIOD;
    w_dr <= "111";
    w_buss <= x"FF07";        
    wait for PERIOD;
    w_regwe <= '0';
    wait for PERIOD;
    w_sr1 <= "000";
    w_sr2 <= "111";
    wait for PERIOD;
    w_sr1 <= "001";
    w_sr2 <= "110";
    wait for PERIOD;
    w_sr1 <= "010";
    w_sr2 <= "101";
    wait for PERIOD;
    w_sr1 <= "011";
    w_sr2 <= "100";
    wait for PERIOD;
    w_sr1 <= "100";
    w_sr2 <= "011";
    wait for PERIOD;
    w_sr1 <= "101";
    w_sr2 <= "010";
    wait for PERIOD;
    w_sr1 <= "110";
    w_sr2 <= "001";
    wait for PERIOD;
    w_sr1 <= "111";
    w_sr2 <= "000";
    wait for PERIOD;
    w_sr1 <= "000";
    w_sr2 <= "000";
    wait for PERIOD;
    w_sr1 <= "001";
    w_sr2 <= "001";
    wait for PERIOD;
    w_sr1 <= "011";
    w_sr2 <= "011";
        
    wait;
  end process STIMULI;
end testbench_arch;
      
     
